﻿<?php
/**
 *	FreshTheme Framework Backup
 * 	---------------------------------------------------------------------------
 *	@author 	: Rifki A.G
 *	@version	: 1.2
 *	@copyright	: Copyright (c) 2012, FreshThemes
 *				  http://www.freshthemes.net
 *				  http://www.rifki.net
 *	@credits	: Devin Price, http://wptheming.com/
 *	              WooThemes, http://www.woothemes.com/
 *				  Gilles Vauvarin, https://github.com/vauvarin
 *	--------------------------------------------------------------------------- */
 
class FreshThemes_Backup {

/*	Constructor 
 *	------------------------------------------------------------------- */
	var $admin_page;
	var $token;
	
	function FreshThemes_Backup(){
		$this->admin_page = '';
		$this->token = 'fresh-panel-backup';
	} 

/*	Initialize the class 
 *	------------------------------------------------------------------- */	
	function init(){
		if ( is_admin() ) {
			add_action( 'admin_menu', array( &$this, 'register_admin_screen' ), 20 );
		}
	} 

/*	Register the admin screen within WordPress.
 *	------------------------------------------------------------------- */		
	function register_admin_screen(){
			
		$this->admin_page = add_submenu_page('fresh-panel', __( 'تنظیمات پشتیبان', THEME_FX ), __( 'تنظیمات پشتیبان', THEME_FX ), 'manage_options', $this->token, array( &$this, 'admin_screen' ) );
		
		if( isset( $_GET['page'] ) && ( $_GET['page'] == $this->token ) ) {
			add_action('admin_enqueue_scripts', 'freshthemes_backup_load_scripts');
			add_action("admin_print_styles-$this->admin_page", 'freshthemes_backup_load_styles');
		}

		/* Loads the CSS */
		function freshthemes_backup_load_styles() {
			wp_enqueue_style('admin-style', THEME_DIR . '/functions/framework/stylesheets/admin-style.css', array(), '1.2' );
		}
		
		/* Loads the CSS */
		function freshthemes_backup_load_scripts() {
			wp_enqueue_script('admin-js', THEME_DIR . '/functions/framework/javascripts/admin.js', array(), '1.2', false );
		}
		
		add_action( 'load-' . $this->admin_page, array( &$this, 'admin_screen_logic' ) );
		add_action( 'admin_notices', array( &$this, 'admin_notices' ), 10 );
	
	} 
	
/*	Backup Front End
 *	------------------------------------------------------------------- */	
	function admin_screen() { 
		$export_type = 'all';
		if ( isset( $_POST['export-type'] ) ) {
			$export_type = esc_attr( $_POST['export-type'] );
		} 
		
		$store_url = 'http://20script.ir/';
		$profile_url = 'http://20script.ir/contact/';
		?>
        <div id="freshthemes" class="wrap">
                <div id="freshthemes-header">
                    <div class="logo">
                    </div>
                    
                    <div class="sep"></div>
                    
                    <div class="themeinfo">
                        <span class="themename"><?php echo THEME_NAME; ?></span>
                        <span class="themeversion">Version: <?php echo THEME_VERSION; ?></span>
                    </div>
                    
                    <div class="sep"></div>
                    
                    <div class="extralinks">
                        <a class="support" href="<?php echo $profile_url; ?>" target="_blank">پشتیبانی</a>
                        <a class="store" href="<?php echo $store_url; ?>" target="_blank">فروشگاه</a>
                    </div>
                </div>
                
                <div id="freshthemes-main">
                    <div id="freshthemes-content-backup">
                        <div class="import-side">
                            <h3>درون‌ریزی</h3>
                            
                            <p><?php _e('قبلا فایل پشتیبان تهیه کرده‌اید؟ لطفا اینجا بارگذاری کنید.', THEME_FX ); ?></p>
                            
                            <form enctype="multipart/form-data" method="post" action="<?php echo admin_url( 'admin.php?page=fresh-panel-backup'); ?>">
                                <?php wp_nonce_field( 'freshthemes-backup-import' ); ?>
                                <input type="file" id="freshthemes-import-file" name="freshthemes-import-file" size="20" />
                                <input type="hidden" name="freshthemes-backup-import" value="1" />
                                <input type="submit" class="button" value="<?php _e( 'بارگذاری', THEME_FX ); ?>" />
                            </form>
                        </div>
                        
                        <div class="export-side">
                            <h3>برون‌ریزی</h3>
                            
                            <p><?php _e('بر دیکمه زیر کلیک کنید تا یک نسخه فایل پشتیبان تهیه کنید.', THEME_FX ); ?></p>
                            
                            <form enctype="multipart/form-data" method="post" action="<?php echo admin_url( 'admin.php?page=fresh-panel-backup'); ?>">
                                <?php wp_nonce_field( 'freshthemes-backup-export' ); ?>
                                <input type="hidden" name="freshthemes-backup-export" value="1" />
                                <input type="submit" class="button button-primary" value="<?php _e( 'ایجاد پشتیبان', THEME_FX ); ?>" />
                            </form>
                        </div>
                        
                        <div class="clear"></div>
                    </div>
                </div>
                
                <div id="freshthemes-footer">
                    <div class="thanks">
                        &copy; تمپ‌ها - <?php printf( __('مرجع <a href="%s" target="_blank">پوسته‌های وردپرس</a>', THEME_FX ), $store_url ); ?>
                    </div>
                </div>
        </div>
		<?php 
	}
	
/*	Add contextual help to the admin screen.
 *	------------------------------------------------------------------- */	
	function admin_notices () {
		if (!isset( $_GET['page'] ) || ( $_GET['page'] != $this->token )) { 
			return;
		}
		
		if (isset( $_GET['error'] ) && $_GET['error'] == 'true') {
			echo '<div id="message" class="error fade"><p>'.__('مشکلی در درون‌ریزی تنظیمات شما وجود دارد. لطفا دوباره تلاش کنید.', THEME_FX ).'</p></div>';
		} 
		else if ( isset( $_GET['error-export'] ) && $_GET['error-export'] == 'true') {  
			echo '<div id="message" class="error fade"><p>'.__( 'مشکلی در برون‌ریزی تنظیمات شما وجود دارد. لطفا دوباره تلاش کنید.', THEME_FX ).'</p></div>';
		} 
		else if (isset( $_GET['invalid'] ) && $_GET['invalid'] == 'true') {  
			echo '<div id="message" class="error fade"><p>'.__('فایل درون‌ریزی که شما تهیه کرده‌اید معتبر نیست. لطفا دوباره تلاش کنید.', THEME_FX ).'</p></div>';
		} 
		else if (isset( $_GET['imported'] ) && $_GET['imported'] == 'true') {  
			echo '<div id="message" class="updated fade"><p>'.__( 'تنظیمات با موفقیت درون‌ریزی شدند.', THEME_FX ).'</p></div>';
		} 
	} 

/*	Performing backup/restore.
 *	------------------------------------------------------------------- */	
	function admin_screen_logic () {
		if (!isset($_POST['freshthemes-backup-export']) 
			&& isset( $_POST['freshthemes-backup-import']) 
			&& ($_POST['freshthemes-backup-import'] == true)) {
			$this->import();
		}
		
		if (!isset($_POST['freshthemes-backup-import']) 
			&& isset($_POST['freshthemes-backup-export']) 
			&& ($_POST['freshthemes-backup-export'] == true)) {
			$this->export();
		}
	} 
	
/*	Import settings from a backup file.
 *	------------------------------------------------------------------- */	
	function import() {
		check_admin_referer( 'freshthemes-backup-import' ); // Security check.
		
		if (!isset( $_FILES['freshthemes-import-file'])) {
			return;
		} // We can't import the settings without a settings file.
		
		// Extract file contents
		$upload = file_get_contents($_FILES['freshthemes-import-file']['tmp_name']);
		
		// Decode the JSON from the uploaded file
		$datafile = json_decode($upload, true);
		
		// Check for errors
		if ( !$datafile || $_FILES['freshthemes-import-file']['error'] ) {
			wp_redirect( admin_url( 'admin.php?page=' . $this->token . '&error=true' ) );
			exit;
		}
		
		// Make sure this is a valid backup file.
		if ( !isset( $datafile['freshthemes-backup-validator'] ) ) {
			wp_redirect( admin_url('admin.php?page=' . $this->token . '&invalid=true' ) );
			exit;
		} 
		else {
			unset( $datafile['freshthemes-backup-validator'] ); // Now that we've checked it, we don't need the field anymore.
		}

		// Get the theme name from the database.
		$freshthemes_data = get_option('freshthemes');
		$freshthemes_name = $freshthemes_data['id'];
		//$freshthemes_name = get_option( $freshthemes_name );
		
		// Update the settings in the database
		if ( update_option( $freshthemes_name, $datafile ) ) {
			wp_redirect( admin_url( 'admin.php?page=' . $this->token . '&imported=true' ) );
			exit;
		} 
		else {
			var_dump($freshthemes_name);
			wp_redirect( admin_url( 'admin.php?page=' . $this->token . '&error=true' ) );
			exit;
		}
		
	} 
	
/*	Export settings to a backup file.
 *	------------------------------------------------------------------- */	
	function export() {
		global $wpdb;
		check_admin_referer( 'freshthemes-backup-export' ); // Security check.
		
		$freshthemes_settings = get_option('freshthemes');
		$database_options = get_option( $freshthemes_settings['id'] );
		
		// Error trapping for the export.
		if ($database_options == '') {
			wp_redirect( admin_url( 'admin.php?page=' . $this->token . '&error-export=true' ) );
			return;
		}
		
		if (!$database_options) {
			return;
		}
	
		// Add our custom marker, to ensure only valid files are imported successfully.
		$database_options['freshthemes-backup-validator'] = date( 'Y-m-d h:i:s' );
	
		// Generate the export file.
	    $output = json_encode( (array)$database_options );
	
	    header( 'Content-Description: File Transfer' );
	    header( 'Cache-Control: public, must-revalidate' );
	    header( 'Pragma: hack' );
	    header( 'Content-Type: text/plain' );
	    header( 'Content-Disposition: attachment; filename="' . THEME_FX . '-option-backup-' . date( 'Ymd-His' ) . '.json"' );
	    header( 'Content-Length: ' . strlen( $output ) );
	    echo $output;
	    exit;
			
	} 
}

/*	Initialize FreshThemes Backup
 *	------------------------------------------------------------------- */
	$ft_backup = new FreshThemes_Backup();
	$ft_backup->init();