/**
 *	FreshTheme Framework Admin Script
 * 	---------------------------------------------------------------------------
 *	@author 	: Rifki A.G
 *	@version	: 1.2
 *	@copyright	: Copyright (c) 2012, FreshThemes
 *				  http://www.freshthemes.net
 *				  http://www.rifki.net
 *	@credits	: Devin Price, http://wptheming.com/
 *	              WooThemes, http://www.woothemes.com/
 *				  Gilles Vauvarin
 *	--------------------------------------------------------------------------- */
 
(function ($) {
	
	var FreshPanel = {
		
		// Open first tab or last opened tab.
		openTabMenu: function() {
			var activetab = '';
			
			$('.group').hide();
			
			if (typeof(localStorage) != 'undefined' ) {
				activetab = localStorage.getItem('activetab');
			}
			
			if (activetab != '' && $(activetab).length ) {
				$(activetab).show();
			} 
			else {
				$('.group:has(".section"):first').show();
			}
			
			if (activetab != '' && $(activetab + '-trigger').length ) {
				if ( $(activetab + '-trigger').hasClass('icon') ) {
					$(activetab + '-trigger').addClass('active')
					.parent().show().addClass('open')
					.parents('li.has-children').addClass('current').addClass('open');
				}
				else {
					$(activetab + '-trigger').addClass('current').addClass('open');
				}
			}
			else {
				if ( $('#freshthemes-tabs ul li:first-child').hasClass('has-children') ) {
					$('#freshthemes-tabs ul li:first-child ul.sub-menu').show().addClass('open')
					.children('li:first').addClass('active')
					.parents('li.has-children').addClass('current').addClass('open');
				}
				else {
					$('#freshthemes-tabs ul li:first-child').addClass('current').addClass('open');
				}
			}
			
		},
		
		// Toggle tab menu.
		toggleTabMenu: function() {
			$('#freshthemes-tabs li.has-children > a').click( function(e) {
				
				if ( $(this).parent().hasClass('open') ) { 
					e.preventDefault();
				}
				
				$('#freshthemes-tabs li.top-level').removeClass('open').removeClass('current');
				$('#freshthemes-tabs li.active').removeClass('active');
				
				if ( $(this).parent().hasClass('open') ) {
					
				} else {
					$('#freshthemes-tabs .sub-menu.open').removeClass('open').slideUp()
					.parent().removeClass('current');
					
					$(this).parent().addClass('open').addClass('current')
					.find('.sub-menu').slideDown().addClass('open')
					.children('li:first').addClass('active');
				}
				
				var clickedGroup = $(this).parent().find('.sub-menu li a:first').attr('href');
				
				if (clickedGroup != '') {
					if (typeof(localStorage) != 'undefined' ) {
						localStorage.setItem("activetab", clickedGroup );
					}
					
					$('.group').hide();
					$(clickedGroup).show();
					
					FreshPanel.resizeWPEditorFrame();
				}
				e.preventDefault();
			});
		},
		
		// Highlight tab menu.
		highlightTabMenu: function() {
			$('#freshthemes-tabs li.top-level').not('.has-children').find('a').click( function(e){
				var thisObj = $(this);
				var clickedGroup = thisObj.attr('href');
				
				if (clickedGroup != '') {
				
					if (typeof(localStorage) != 'undefined' ) {
						localStorage.setItem("activetab", clickedGroup );
					}
					
					$('#freshthemes-tabs .open').removeClass('open');
					$('.sub-menu').slideUp();
					$('#freshthemes-tabs .active').removeClass('active');
					$('#freshthemes-tabs li.current').removeClass('current');
					thisObj.parent().addClass('current');
					
					$('.group').hide();
					$(clickedGroup).show();
					
					FreshPanel.resizeWPEditorFrame();
					
					return false;
				}
			});
			
			$('#freshthemes-tabs li:not(".has-children") > a:first').click( function(e) {
				var parentObj = $(this).parent('li');
				var thisObj = $(this);
				
				var clickedGroup = thisObj.attr('href');
				
				if (typeof(localStorage) != 'undefined' ) {
					localStorage.setItem("activetab", clickedGroup );
				}
				
				if ( $(this).parents('.top-level').hasClass('open')) {
					
				} else {
					$('#freshthemes-tabs li.top-level').removeClass('current').removeClass('open');
					$('#freshthemes-tabs .sub-menu').removeClass('open').slideUp();
					$(this).parents('li.top-level').addClass('current');
				}
			
				$('.group').hide();
				$(clickedGroup).show();
				
				FreshPanel.resizeWPEditorFrame();
			
				e.preventDefault();
			});
			
			$('.sub-menu a').click( function(e) {
				var thisObj = $(this);
				var parentMenu = $(this).parents('li.top-level');
				var clickedGroup = thisObj.attr('href');
				
				if ( $('.sub-menu li a[href="' + clickedGroup + '"]').hasClass('active') ) {
					return false;
				}
				
				if ( clickedGroup != '' ) {
				
					if (typeof(localStorage) != 'undefined' ) {
						localStorage.setItem("activetab", clickedGroup );
					}
				
					parentMenu.addClass('open');
					$('.sub-menu li, .flyout-menu li').removeClass('active');
					$(this).parent().addClass('active');
					$('.group').hide();
					$(clickedGroup).show();
					
					FreshPanel.resizeWPEditorFrame();
				}
				
				e.preventDefault();
			});
		},
		
		// FlyOut menu, like the WordPress has :).
		flyoutMenu: function() {
			$('#freshthemes-tabs li.has-children').each( function() {
				$(this).hover(
					function () {
						if ( $(this).find('.flyout-menu').length == 0 ) {
							var flyoutContents = $(this).find('.sub-menu').html();
							var flyoutMenu = $('<div />').addClass('flyout-menu').html('<ul>' + flyoutContents + '</ul>');
							$(this).append(flyoutMenu);
						}
					}
				);
			});
			
			$('.flyout-menu a').live('click', function (e) {
				var thisObj = $(this);
				var parentObj = $(this).parent();
				var parentMenu = $(this).parents('.top-level');
				var clickedGroup = $(this).attr('href');
				
				if (clickedGroup != '') {
					if (typeof(localStorage) != 'undefined' ) {
						localStorage.setItem("activetab", clickedGroup );
					}
					
					$('.group').hide();
					$(clickedGroup).show();
					$('#freshthemes-tabs li').removeClass('open').removeClass('current').find('.sub-menu').slideUp().removeClass('open');
					parentMenu.addClass('open').addClass('current').find('.sub-menu').slideDown().addClass('open');
					$('#freshthemes-tabs li.active').removeClass('active');
					$('#freshthemes-tabs a[href="' + clickedGroup + '"]').parent().addClass('active');
					
					FreshPanel.resizeWPEditorFrame();
				}
				
				e.preventDefault();
			});
		},
		
		// Radio image selector.
		imageSelector: function() {
			$('.freshthemes-radio-img-img').click(function(){
				$(this).parent().parent().find('.freshthemes-radio-img-img').removeClass('freshthemes-radio-img-selected');
				$(this).addClass('freshthemes-radio-img-selected');		
			});
				
			$('.freshthemes-radio-img-label').hide();
			$('.freshthemes-radio-img-img').show();
			$('.freshthemes-radio-img-radio').hide();
		},
		
		// Initialize "ColorPicker" plugin.
		initColorPicker: function() {
			$('.colorSelector').each(function(){
				var Othis = this; //cache a copy of the this variable for use inside nested function
				var initialColor = $(Othis).next('input').attr('value');
				$(this).ColorPicker({
					color: initialColor,
					onShow: function (colpkr) {
						$(colpkr).fadeIn(500);
						return false;
					},
					onHide: function (colpkr) {
						$(colpkr).fadeOut(500);
						return false;
					},
					onChange: function (hsb, hex, rgb) {
						$(Othis).children('div').css('backgroundColor', '#' + hex);
						$(Othis).next('input').attr('value','#' + hex);
					}
				});
			});
		},
		
		// WP text-editor need improvement.
		resizeWPEditorFrame: function() {
			var newHeight = $('.section-editor .wp-editor-area').height();
			$('.section-editor .mceIframeContainer iframe').height( newHeight );
		},
		
		// Initialize
		init: function() {
			FreshPanel.openTabMenu();
			FreshPanel.toggleTabMenu();
			FreshPanel.highlightTabMenu();
			FreshPanel.flyoutMenu();
			FreshPanel.imageSelector();
			FreshPanel.initColorPicker();
		}
		
	}
	
	// Run the magic.
	$(document).ready(function(e) {
        
		// Initialize "FreshPanel".
		FreshPanel.init();
		
		// Fade out the save message
		$('.fade').delay(1000).fadeOut(1000);
    });
	
})(jQuery);