﻿<?php
/**
 *	FreshThemes Dribbble Shots Widget
 * 	---------------------------------------------------------------------------
 *	@author 	: Rifki Aria Gumelar
 *	@version	: 1.0
 *	@link		: http://www.20script.ir
 *	@copyright	: Copyright (c) 2012, http://www.freshthemes.net
 *	--------------------------------------------------------------------------- */
 
/*	Register Widget
 *	---------------------------------------- */
	add_action( 'widgets_init', 'register_ft_dribbble_widget' );

	function register_ft_dribbble_widget() {
		register_widget( 'ft_dribbble_widget' );
	}
 
/*	Widget Class
 *	---------------------------------------- */ 
	class ft_dribbble_widget extends WP_Widget {
		
		/* Constructor */
		function ft_dribbble_widget() {
			$widget_ops = array( 'classname' => 'dribbble-widget', 'description' => __('یک ابزارک برای نمایش شات‌های دریبل.', THEME_FX) );
			$control_ops = array( 'width' => 300, 'height' => 350, 'id_base' => 'ft-dribbble-widget' );
			$this->WP_Widget( 'ft-dribbble-widget', THEME_NAME . ' شات‌های دریبل', $widget_ops, $control_ops );
		}
		
		/* Widget display */
		function widget( $args, $instance ) {
			extract( $args );

			$title = apply_filters('widget_title', $instance['title'] );
			$dribbble_id = $instance['dribbble_id'];
			$dribbble_count = $instance['dribbble_count'];
		
			echo $before_widget  . "\n";
			if ( $title )
			echo $before_title . $title . $after_title  . "\n"; 
		
			if ( $dribbble_id )
			echo '<div id="dribbble_'.$dribbble_id.'" class="dribbble_shots"><ul></ul></div>' . "\n"; ?>
			<script type="text/javascript">
			//<![CDATA[
			jQuery(document).ready(function($) {
				$.jribbble.getShotsByPlayerId('<?php echo $dribbble_id; ?>', function (playerShots) { 
					var html = [];
					$.each(playerShots.shots, function (i, shot) {
						html.push('<li><a href="' + shot.url + '">');
						html.push('<img src="' + shot.image_teaser_url + '" ');
						html.push('title="' + shot.title + '"></a></li>');
					});
			
					$('#dribbble_<?php echo $dribbble_id; ?> ul').html(html.join(''));
				}, {page: 1, per_page: <?php echo $dribbble_count; ?>});    
			});
			//]]>
			</script>
			<?php
			echo $after_widget  . "\n\n" ;
		}
		
		/* Update widget settings */
		function update( $new_instance, $old_instance ) {
			$instance = $old_instance;
			$instance['title'] 		= strip_tags( $new_instance['title'] );
			$instance['dribbble_id']	= strip_tags( $new_instance['dribbble_id'] );
			$instance['dribbble_count'] = $new_instance['dribbble_count'];
			
			return $instance;
		}
		
		/* Widget form */
		function form( $instance ) {
			
			$defaults = array( 
				'title' => 'Dribbble Shots',
				'dribbble_id' => '',
				'dribbble_count' => '9'
			);
			
			$instance = wp_parse_args( (array) $instance, $defaults ); ?>
		
			<p>
				<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e('عنوان:', THEME_FX) ?></label>
				<input type="text" class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" value="<?php echo $instance['title']; ?>" />
			</p>
		
			<p>
				<label for="<?php echo $this->get_field_id( 'dribbble_id' ); ?>"><?php _e('شناسه دریبل:', THEME_FX) ?></label>
				<input type="text" class="widefat" id="<?php echo $this->get_field_id( 'dribbble_id' ); ?>" name="<?php echo $this->get_field_name( 'dribbble_id' ); ?>" value="<?php echo $instance['dribbble_id']; ?>" />
			</p>
		
			<p>
				<label for="<?php echo $this->get_field_id( 'dribbble_count' ); ?>"><?php _e('تعداد شات‌ها:', THEME_FX) ?></label>
				<input type="text" class="widefat" id="<?php echo $this->get_field_id( 'dribbble_count' ); ?>" name="<?php echo $this->get_field_name( 'dribbble_count' ); ?>" value="<?php echo $instance['dribbble_count']; ?>" />
			</p>
			
			<?php 
		}
		
	}
 
?>