<?php
/**
 *	FreshThemes Flickr Shots Widget
 * 	---------------------------------------------------------------------------
 *	@author 	: Rifki Aria Gumelar
 *	@version	: 1.0
 *	@link		: http://www.freshthemes.net
 *	@copyright	: Copyright (c) 2012, http://www.freshthemes.net
 *	--------------------------------------------------------------------------- */
 
/*	Register Widget
 *	---------------------------------------- */
	add_action( 'widgets_init', 'register_ft_flickr_widget' );

	function register_ft_flickr_widget() {
		register_widget( 'ft_flickr_widget' );
	}
 
/*	Widget Class
 *	---------------------------------------- */ 
	class ft_flickr_widget extends WP_Widget {
		
		/* Constructor */
		function ft_flickr_widget() {
			$widget_ops = array( 'classname' => 'flickr-widget', 'description' => __('یک ابزارک برای نمایش تصاویر فلیکر.', THEME_FX) );
			$control_ops = array( 'width' => 300, 'height' => 350, 'id_base' => 'ft-flickr-widget' );
			$this->WP_Widget( 'ft-flickr-widget', THEME_NAME . ' فلیکر', $widget_ops, $control_ops );
		}
		
		/* Widget display */
		function widget( $args, $instance ) {
			extract( $args );

			$title = apply_filters('widget_title', $instance['title'] );
			$flickr_id = $instance['flickr_id'];
			$flickr_count = $instance['flickr_count'];
		
			echo $before_widget  . "\n";
			if ( $title )
			echo $before_title . $title . $after_title  . "\n"; 
		
			if ( $flickr_id )
			echo '<div id="flickr_'. str_replace('@', '', $flickr_id) .'" class="flickr_photos"><ul></ul></div>' . "\n"; ?>
			<script type="text/javascript">
			//<![CDATA[
			jQuery(document).ready(function($) {
				$('#flickr_<?php echo str_replace('@', '', $flickr_id); ?> ul').jflickrfeed({
					limit: <?php echo $flickr_count; ?>,
					qstrings: {
						id: '<?php echo $flickr_id; ?>'
					},
					itemTemplate: '<li><a href="{{link}}"><img class="flickr" src="{{image_s}}" alt="{{title}}"></a></li>'
				});	
            });	
			//]]>
			</script>
			<?php
			echo $after_widget  . "\n\n" ;
		}
		
		/* Update widget settings */
		function update( $new_instance, $old_instance ) {
			$instance = $old_instance;
			$instance['title'] 		= strip_tags( $new_instance['title'] );
			$instance['flickr_id']	= strip_tags( $new_instance['flickr_id'] );
			$instance['flickr_count'] = $new_instance['flickr_count'];
			
			return $instance;
		}
		
		/* Widget form */
		function form( $instance ) {
			
			$defaults = array( 
				'title' => 'فلیکر',
				'flickr_id' => '',
				'flickr_count' => '9'
			);
			
			$instance = wp_parse_args( (array) $instance, $defaults ); ?>
		
			<p>
				<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e('عنوان:', THEME_FX) ?></label>
				<input type="text" class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" value="<?php echo $instance['title']; ?>" />
			</p>
		
			<p>
				<label for="<?php echo $this->get_field_id( 'flickr_id' ); ?>"><?php _e('شناسه فلیکر:', THEME_FX) ?></label>
				<input type="text" class="widefat" id="<?php echo $this->get_field_id( 'flickr_id' ); ?>" name="<?php echo $this->get_field_name( 'flickr_id' ); ?>" value="<?php echo $instance['flickr_id']; ?>" />
			</p>
		
			<p>
				<label for="<?php echo $this->get_field_id( 'flickr_count' ); ?>"><?php _e('تعداد عکس‌ها:', THEME_FX) ?></label>
				<input type="text" class="widefat" id="<?php echo $this->get_field_id( 'flickr_count' ); ?>" name="<?php echo $this->get_field_name( 'flickr_count' ); ?>" value="<?php echo $instance['flickr_count']; ?>" />
			</p>
			
			<?php 
		}
		
	}
 
?>