﻿<?php
/**
 *	FreshThemes Recent Posts
 * 	---------------------------------------------------------------------------
 *	@author 	: Rifki Aria Gumelar
 *	@version	: 1.0
 *	@link		: http://www.20script.ir
 *	@copyright	: Copyright (c) 2012, http://www.freshthemes.net
 *	--------------------------------------------------------------------------- */
 
/*	Register Widget
 *	---------------------------------------- */
	add_action( 'widgets_init', 'register_ft_popular_posts_widget' );

	function register_ft_popular_posts_widget() {
		register_widget( 'ft_popular_posts_widget' );
	}
 
/*	Widget Class
 *	---------------------------------------- */ 
	class ft_popular_posts_widget extends WP_Widget {
	
		/* Constructor */
		function ft_popular_posts_widget() {
			$widget_ops = array( 'classname' => 'popular-posts-widget', 'description' => __('یک ابزارک برای نمایش نوشته‌های محبوب که می‌توانند بر اساس تعداد دیدگاه یا تعداد بازدید با یا بدون تصویر مرتب شوند.', THEME_FX) );
			$control_ops = array( 'width' => 300, 'height' => 350, 'id_base' => 'ft-popular-posts-widget' );
			$this->WP_Widget( 'ft-popular-posts-widget', THEME_NAME . ' نوشته‌های محبوب', $widget_ops, $control_ops );
		}
		
		/* Widget display */
		function widget( $args, $instance ) {
			extract( $args );

			$popular_type = $instance['popular_type'];
			$title = apply_filters('widget_title', $instance['title'] );
			$posts_number = $instance['posts_number'];
			$thumb = $instance['thumb'];
			
			if( $popular_type == 'views' ) :
				$type = '&v_sortby=views';
			else :
				$type = '&orderby=comment_count';
			endif;
		
			echo $before_widget . "\n";
			
			
			if ( $title )
			echo $before_title . $title . $after_title . "\n"; ?> 
			
			<div class="entry-list <?php if(!$thumb) : echo 'no-thumb'; endif; ?> clearfix">
				<ul>
        		<?php $query = new WP_Query( 'post_type=post&posts_per_page='.$posts_number. $type ); ?>
				<?php while ( $query->have_posts() ) : $query->the_post(); ?>
				<?php echo freshthemes_print_entry_list($thumb); ?>
				<?php endwhile; ?>
				<?php wp_reset_postdata(); ?>
				</ul>
			</div>
			
		<?php echo $after_widget . "\n\n";
		}
		
		/* Update widget settings */
		function update( $new_instance, $old_instance ) {
			$instance = $old_instance;
			$instance['title'] = strip_tags( $new_instance['title'] );
			$instance['thumb'] = ( isset( $new_instance['thumb'] ) ? 1 : 0 ); 
			$instance['popular_type'] = $new_instance['popular_type'];
			$instance['posts_number'] = $new_instance['posts_number'];
			
			return $instance;
		}
		
		/* Widget form */
		function form( $instance ) {
			
			$defaults = array( 
				'title' => '',
				'thumb' => true,
				'popular_type' => '',
				'posts_number' => '4',
			);
			
			$instance = wp_parse_args( (array) $instance, $defaults ); ?>
		
			<p>
				<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e('عنوان:', THEME_FX ) ?></label>
				<input type="text" class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" value="<?php echo $instance['title']; ?>" />
			</p>
            
            <p>
				<label for="<?php echo $this->get_field_id( 'thumb' ); ?>"><?php _e('نمایش تصویر بندانگشتی؟', THEME_FX ) ?></label>
				<input class="checkbox" type="checkbox" <?php checked( $instance['thumb'], true ); ?> id="<?php echo $this->get_field_id( 'thumb' ); ?>" name="<?php echo $this->get_field_name( 'thumb' ); ?>" /> 
			</p>
            
            <?php $cats_array = get_categories('hide_empty=0'); ?>
			<p>
			<label for="<?php echo $this->get_field_id('popular_type'); ?>"><?php _e('نوع محبوبیت', THEME_FX); ?></label>
			<select name="<?php echo $this->get_field_name('popular_type'); ?>" id="<?php echo $this->get_field_id('popular_type'); ?>" class="widefat">
				<option value="comment_count"<?php selected( $instance['popular_type'], 'comment_count' ); ?>><?php _e('تعداد دیدگاه‌ها', THEME_FX ); ?></option>
                <option value="views"<?php selected( $instance['popular_type'], 'views' ); ?>><?php _e('تعداد بازدید', THEME_FX ); ?></option>
			</select>
			</p> 
		
			<p>
				<label for="<?php echo $this->get_field_id( 'posts_number' ); ?>"><?php _e('تعداد نوشته‌ها:', THEME_FX ) ?></label>
				<input type="number" class="widefat" id="<?php echo $this->get_field_id( 'posts_number' ); ?>" name="<?php echo $this->get_field_name( 'posts_number' ); ?>" value="<?php echo $instance['posts_number']; ?>" />
			</p>
			
			<?php 
		}
	}