﻿<?php
/**
 *	FreshThemes Recent audio Widget
 * 	---------------------------------------------------------------------------
 *	@author 	: Rifki Aria Gumelar
 *	@version	: 1.0
 *	@link		: http://www.20script.ir
 *	@copyright	: Copyright (c) 2012, http://www.freshthemes.net
 *	--------------------------------------------------------------------------- */
 
/*	Register Widget
 *	---------------------------------------- */
	add_action( 'widgets_init', 'register_ft_recent_audio_widget' );

	function register_ft_recent_audio_widget() {
		register_widget( 'ft_recent_audio_widget' );
	}
 
/*	Widget Class
 *	---------------------------------------- */ 
	class ft_recent_audio_widget extends WP_Widget {
		
		/* Constructor */
		function ft_recent_audio_widget() {
			$widget_ops = array( 'classname' => 'recent-audio', 'description' => __('یک ابزارک برای نمایش تازه‌ترین نوشته‌های صوتی شما.', THEME_FX) );
			$control_ops = array( 'width' => 300, 'height' => 350, 'id_base' => 'ft-recent-audio-widget' );
			$this->WP_Widget( 'ft-recent-audio-widget', THEME_NAME . ' تازه‌ترین صوت‌ها', $widget_ops, $control_ops );
		}
		
		/* Widget display */
		function widget( $args, $instance ) {
			extract( $args );

			$title = apply_filters('widget_title', $instance['title'] );
		
			echo $before_widget  . "\n";
			if ( $title )
			echo $before_title . $title . $after_title  . "\n"; 
			
			echo '<div class="audio-widget">' . "\n";
			$query = new WP_Query( array( 'posts_per_page' => 1, 'post_format' => 'post-format-audio' ) );
			while ( $query->have_posts() ) : $query->the_post();
			
			$audio_file = get_post_meta( get_the_ID(), THEME_FX . 'audio_url', true );
			$audio_format = get_post_meta( get_the_ID(), THEME_FX . 'audio_format', true );
			$audio_add_file = get_post_meta( get_the_ID(), THEME_FX . 'audio_add_url', true );
			
			if( $audio_file ) : ?>
			<?php echo freshthemes_print_audio_player('prefix=recent_audio&file='.$audio_file.'&additional_file='.$audio_add_file.'&format='.$audio_format); ?>
			<?php endif;
			endwhile; wp_reset_postdata();
			echo '</div>' . "\n";
			
			echo $after_widget  . "\n\n" ;
		}
		
		/* Update widget settings */
		function update( $new_instance, $old_instance ) {
			$instance = $old_instance;
			$instance['title'] 		= strip_tags( $new_instance['title'] );
			
			return $instance;
		}
		
		/* Widget form */
		function form( $instance ) {
			
			$defaults = array( 
				'title' => 'تازه‌ترین صوت‌ها',
			);
			
			$instance = wp_parse_args( (array) $instance, $defaults ); ?>
		
			<p>
				<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e('عنوان:', THEME_FX) ?></label>
				<input type="text" class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" value="<?php echo $instance['title']; ?>" />
			</p>
			
			<?php 
		}
		
	}
 
?>