﻿<?php
/**
 *	FreshThemes Recent Video Widget
 * 	---------------------------------------------------------------------------
 *	@author 	: Rifki Aria Gumelar
 *	@version	: 1.0
 *	@link		: http://www.20script.ir
 *	@copyright	: Copyright (c) 2012, http://www.freshthemes.net
 *	--------------------------------------------------------------------------- */
 
/*	Register Widget
 *	---------------------------------------- */
	add_action( 'widgets_init', 'register_ft_recent_video_widget' );

	function register_ft_recent_video_widget() {
		register_widget( 'ft_recent_video_widget' );
	}
 
/*	Widget Class
 *	---------------------------------------- */ 
	class ft_recent_video_widget extends WP_Widget {
		
		/* Constructor */
		function ft_recent_video_widget() {
			$widget_ops = array( 'classname' => 'recent-video', 'description' => __('یک ابزارک برای نمایش آخرین نوشته‌های ویدئویی شما.', THEME_FX) );
			$control_ops = array( 'width' => 300, 'height' => 350, 'id_base' => 'ft-recent-video-widget' );
			$this->WP_Widget( 'ft-recent-video-widget', THEME_NAME . ' تازه‌ترین ویدئو‌ها', $widget_ops, $control_ops );
		}
		
		/* Widget display */
		function widget( $args, $instance ) {
			extract( $args );

			$title = apply_filters('widget_title', $instance['title'] );
		
			echo $before_widget  . "\n";
			if ( $title )
			echo $before_title . $title . $after_title  . "\n"; 
			
			echo '<div class="video-widget">' . "\n";
			$query = new WP_Query( array( 'posts_per_page' => 1, 'post_format' => 'post-format-video' ) );
			while ( $query->have_posts() ) : $query->the_post();
			
			$video_url = get_post_meta( get_the_ID(), THEME_FX . 'video_url', true );
			
			if( $video_url ) : ?>
			<div class="video-container">
        	<?php echo wp_oembed_get($video_url, array( 'width'=> 293 )); ?>
			</div>
			<?php endif;
			endwhile; wp_reset_postdata();
			echo '</div>' . "\n";
			
			echo $after_widget  . "\n\n" ;
		}
		
		/* Update widget settings */
		function update( $new_instance, $old_instance ) {
			$instance = $old_instance;
			$instance['title'] 		= strip_tags( $new_instance['title'] );
			
			return $instance;
		}
		
		/* Widget form */
		function form( $instance ) {
			
			$defaults = array( 
				'title' => 'تازه‌ترین ویدئو‌ها',
			);
			
			$instance = wp_parse_args( (array) $instance, $defaults ); ?>
		
			<p>
				<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e('عنوان:', THEME_FX) ?></label>
				<input type="text" class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" value="<?php echo $instance['title']; ?>" />
			</p>
			
			<?php 
		}
		
	}
 
?>