<?php

$path_to_file = explode( 'wp-content', __FILE__ );
$path_to_wp = $path_to_file[0];

require_once( $path_to_wp . '/wp-load.php' );

class Fresh_Shortcodes {
	
	var	$popup;
	var	$params;
	var	$shortcode;
	var $cparams;
	var $cshortcode;
	var $popup_title;
	var $no_preview;
	var $has_child;
	var	$output;
	var	$errors;
	
	function __construct( $popup ) {
		$this->popup = $popup;
		$this->show();
	}
	
	function show() {
		
		global $fresh_shortcodes_config;
		
		$fresh_shortcodes = $fresh_shortcodes_config;
		
		if( isset( $fresh_shortcodes[$this->popup]['child'] ) )
			$this->has_child = true;
			
		if( isset( $fresh_shortcodes ) && is_array( $fresh_shortcodes ) ) {
			
			$this->params = $fresh_shortcodes[$this->popup]['params'];
			$this->shortcode = $fresh_shortcodes[$this->popup]['shortcode'];
			$this->popup_title = $fresh_shortcodes[$this->popup]['popup_title'];
			
			$this->append_output('<div id="_fresh_shortcodes_output" class="hidden">'.$this->shortcode.'</div>');
			$this->append_output('<div id="_fresh_shortcodes_popup" class="hidden">'.$this->popup.'</div>');
				
			if( isset( $fresh_shortcodes[$this->popup]['no_preview'] ) && $fresh_shortcodes[$this->popup]['no_preview'] ) {
				$this->append_output( "\n" . '<div id="_fresh_shortcodes_preview" class="hidden">false</div>' );
				$this->no_preview = true;		
			}
			
			foreach( $this->params as $key => $param ) {
				
				$key = 'fresh_shortcode_' . $key;
				
				// popup form row start
				$row_start  = '<tbody>';
				$row_start .= '<tr class="form-row">';
				$row_start .= '<td class="label">' . $param['label'] . '</td>';
				$row_start .= '<td class="field">';
				
				// popup form row end
				$row_end	= '<span class="fresh-shortcodes-form-desc">' . $param['desc'] . '</span>';
				$row_end   .= '</td>';
				$row_end   .= '</tr>';					
				$row_end   .= '</tbody>';
				
				switch( $param['type'] ) {
					
					case 'text' :		
						$output  = $row_start;
						$output .= '<input type="text" class="fresh-shortcodes-input" name="'.$key.'" id="'.$key.'" value="'.$param['std'].'" />';
						$output .= $row_end;
						
						$this->append_output( $output );	
						break;
						
					case 'textarea' :
						$output  = $row_start;
						$output .= '<textarea class="fresh-shortcodes-input fresh-shortcodes-textarea" name="'.$key.'" id="'.$key.'" >'.$param['std'].'</textarea>';
						$output .= $row_end;
						
						$this->append_output( $output );		
						break;
						
					case 'select' :		
						$output  = $row_start;
						$output .= '<select name="'.$key.'" id="'.$key.'" class="fresh-shortcodes-input select fresh-shortcodes-select">';
						foreach( $param['options'] as $value => $option ) {
							$output .= '<option value="'.$value.'">'.$option.'</option>';
						}
						$output .= '</select>';
						$output .= $row_end;
				
						$this->append_output( $output );	
						break;
						
					case 'checkbox' :
						$output  = $row_start;
						$output .= '<label for="'.$key.'">';
						$output .= '<input type="checkbox" class="fresh-shortcodes-input fresh-shortcodes-checkbox" name="'.$key.'" id="'.$key.'" '.( $param['std'] ? 'checked' : '' ).' />';
						$output .= $param['checkbox_text'].'</label>';
						$output .= $row_end;
			
						$this->append_output( $output );
						break;
						
				}
					
			}
			
			if( isset( $fresh_shortcodes[$this->popup]['child'] ) ) {
				
				$this->child_params = $fresh_shortcodes[$this->popup]['child']['params'];
				$this->child_shortcode = $fresh_shortcodes[$this->popup]['child']['shortcode'];
				
				$parent_row_start  = '<tbody>';
				$parent_row_start .= '<tr class="form-row has-child">';
				$parent_row_start .= '<td><a href="#" id="form-child-add" class="button button-secondary">'.$fresh_shortcodes[$this->popup]['child']['clone'].'</a>';
				$parent_row_start .= '<div class="child-clone-rows">';
				$parent_row_start .= '<div id="_fresh_shortcodes_child_output" class="hidden">'.$this->child_shortcode.'</div>';
				$parent_row_start .= '<div class="child-clone-row">';
				$parent_row_start .= '<ul class="child-clone-row-form">';
			
				$this->append_output( $parent_row_start );
				
				foreach( $this->child_params as $child_key => $child_param ) {
					
					$child_key = 'fresh_shortcode_' . $child_key;
					
					$child_row_start  = '<li class="child-clone-row-form-row">';
					$child_row_start .= '<div class="child-clone-row-label">';
					$child_row_start .= '<label>' . $child_param['label'] . '</label>';
					$child_row_start .= '</div>';
					$child_row_start .= '<div class="child-clone-row-field">';
				
					$child_row_end	  = '<span class="child-clone-row-desc">'.$child_param['desc'].'</span>';
					$child_row_end   .= '</div>';
					$child_row_end   .= '</li>';
					
					switch( $child_param['type'] ) {
						
						case 'text' :		
							$child_output  = $child_row_start;
							$child_output .= '<input type="text" class="fresh-shortcodes-child-input" name="'.$child_key.'" id="'.$child_key.'" value="'.$child_param['std'].'" />';
							$child_output .= $child_row_end;
							
							$this->append_output( $child_output );	
							break;
							
						case 'textarea' :
							$child_output  = $child_row_start;
							$child_output .= '<textarea class="fresh-shortcodes-child-input fresh-shortcodes-textarea" name="'.$child_key.'" id="'.$child_key.'">'.$child_param['std'].'</textarea>';
							$child_output .= $child_row_end;
							
							$this->append_output( $child_output );		
							break;
							
						case 'select' :		
							$child_output  = $child_row_start;
							$child_output .= '<select name="'.$child_key.'" id="'.$child_key.'" class="fresh-shortcodes-child-input select fresh-shortcodes-select">';
							foreach( $child_param['options'] as $value => $option ) {
								$child_output .= '<option value="'.$value.'">'.$option.'</option>';
							}
							$child_output .= '</select>';
							$child_output .= $child_row_end;
					
							$this->append_output( $child_output );	
							break;
							
						case 'checkbox' :
							$child_output  = $child_row_start;
							$child_output .= '<label for="'.$child_key.'">';
							$child_output .= '<input type="checkbox" class="fresh-shortcodes-child-input fresh-shortcodes-checkbox" name="'.$child_key.'" id="'.$child_key.'" '.( $param['std'] ? 'checked' : '' ).' />';
							$child_output .= $child_param['checkbox_text'].'</label>';
							$child_output .= $child_row_end;
				
							$this->append_output( $child_output );
							break;
						
					}
					
				}
				
				$parent_row_end    = '</ul>';
				$parent_row_end   .= '<a href="#" class="child-clone-row-remove">Remove</a>';
				$parent_row_end   .= '</div>';
				$parent_row_end   .= '</div>';
				$parent_row_end   .= '</td>';
				$parent_row_end   .= '</tr>';			
				$parent_row_end   .= '</tbody>';
			
				$this->append_output( $parent_row_end );
			}
		}
		
	}
	
	function append_output( $output ) {
		$this->output = $this->output . $output;		
	}

	function reset_output( $output ) {
		$this->output = '';
	}

	function append_error( $error ) {
		$this->errors = $this->errors . $error;
	}
	
}